"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const react_1 = require("react");
const head_1 = require("./head");
exports.Uploader = ({ id, children, initialPath, uploadFile, onUploaded, onError }) => {
    const [path, setPath] = react_1.useState(initialPath);
    const [uploading, setUploading] = react_1.useState(false);
    const [progress, setProgress] = react_1.useState(0);
    const fileInput = react_1.useRef(null);
    const onChange = react_1.useCallback(() => __awaiter(this, void 0, void 0, function* () {
        if (!fileInput.current) {
            return;
        }
        const currentFile = head_1.head(fileInput.current.files);
        if (!currentFile) {
            return;
        }
        try {
            setUploading(true);
            setProgress(0);
            const { path: newPath } = yield uploadFile(currentFile, setProgress);
            setPath(newPath);
            if (onUploaded) {
                onUploaded(newPath);
            }
        }
        catch (err) {
            onError(err);
        }
        finally {
            setUploading(false);
        }
    }), [path, fileInput, uploadFile]);
    return (React.createElement(React.Fragment, null,
        React.createElement("label", { htmlFor: id },
            React.createElement("input", { style: { display: "none" }, onChange: onChange, type: "file", ref: fileInput, id: id }),
            children({ path, uploading, progress }))));
};
//# sourceMappingURL=index.js.map